Skip to main content
PUT
/
templates
/
{id}
@firma-dev/sdk
import { FirmaClient } from "@firma-dev/sdk";

const firma = new FirmaClient({ apiKey: "YOUR_API_KEY" });

const response = await firma.templates.updateTemplate({
    id: "id"
});
console.log(response);
curl --request PUT \
--url https://api.firma.dev/functions/v1/signing-request-api/templates/{id} \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"template_properties": {
"name": "<string>",
"description": "<string>",
"document": "aSDinaTvuI8gbWludGxpZnk=",
"expiration_hours": 2,
"settings": {
"allow_editing_before_sending": true,
"attach_pdf_on_finish": true,
"allow_download": true,
"hand_drawn_only": true,
"require_otp_verification": true,
"disable_guided_navigation": true,
"allow_presigning_download": true,
"show_qr_code": true
}
},
"users": [
{
"first_name": "<string>",
"email": "jsmith@example.com",
"order": 2,
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"last_name": "<string>",
"phone_number": "<string>",
"street_address": "<string>",
"city": "<string>",
"state_province": "<string>",
"postal_code": "<string>",
"country": "<string>",
"title": "<string>",
"company": "<string>"
}
],
"force_remove_conditions": false,
"deleted_users": [
{
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"reassign_to_user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"fields": [
{
"x": 50,
"y": 50,
"width": 50,
"height": 50,
"page": 2,
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"required": false,
"assigned_to_user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"options": [
"<string>"
],
"default_to_signing_date": true,
"multi_group_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"variable_name": "<string>",
"variable_defined_name": "<string>",
"required_conditions": {
"groups": [
{
"conditions": [
{
"field_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"value": "<string>"
}
]
}
]
},
"visibility_conditions": {
"groups": [
{
"conditions": [
{
"field_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"value": "<string>"
}
]
}
]
}
}
],
"reminders": [
{
"hours": 2,
"subject": "<string>",
"message": "<string>",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"all_users": false,
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
'
import requests

url = "https://api.firma.dev/functions/v1/signing-request-api/templates/{id}"

payload = {
"template_properties": {
"name": "<string>",
"description": "<string>",
"document": "aSDinaTvuI8gbWludGxpZnk=",
"expiration_hours": 2,
"settings": {
"allow_editing_before_sending": True,
"attach_pdf_on_finish": True,
"allow_download": True,
"hand_drawn_only": True,
"require_otp_verification": True,
"disable_guided_navigation": True,
"allow_presigning_download": True,
"show_qr_code": True
}
},
"users": [
{
"first_name": "<string>",
"email": "jsmith@example.com",
"order": 2,
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"last_name": "<string>",
"phone_number": "<string>",
"street_address": "<string>",
"city": "<string>",
"state_province": "<string>",
"postal_code": "<string>",
"country": "<string>",
"title": "<string>",
"company": "<string>"
}
],
"force_remove_conditions": False,
"deleted_users": [
{
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"reassign_to_user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
],
"fields": [
{
"x": 50,
"y": 50,
"width": 50,
"height": 50,
"page": 2,
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"required": False,
"assigned_to_user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"options": ["<string>"],
"default_to_signing_date": True,
"multi_group_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"variable_name": "<string>",
"variable_defined_name": "<string>",
"required_conditions": { "groups": [{ "conditions": [
{
"field_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"value": "<string>"
}
] }] },
"visibility_conditions": { "groups": [{ "conditions": [
{
"field_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"value": "<string>"
}
] }] }
}
],
"reminders": [
{
"hours": 2,
"subject": "<string>",
"message": "<string>",
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"all_users": False,
"user_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
]
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'PUT',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
template_properties: {
name: '<string>',
description: '<string>',
document: 'aSDinaTvuI8gbWludGxpZnk=',
expiration_hours: 2,
settings: {
allow_editing_before_sending: true,
attach_pdf_on_finish: true,
allow_download: true,
hand_drawn_only: true,
require_otp_verification: true,
disable_guided_navigation: true,
allow_presigning_download: true,
show_qr_code: true
}
},
users: [
{
first_name: '<string>',
email: 'jsmith@example.com',
order: 2,
id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
last_name: '<string>',
phone_number: '<string>',
street_address: '<string>',
city: '<string>',
state_province: '<string>',
postal_code: '<string>',
country: '<string>',
title: '<string>',
company: '<string>'
}
],
force_remove_conditions: false,
deleted_users: [
{
user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
reassign_to_user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a'
}
],
fields: [
{
x: 50,
y: 50,
width: 50,
height: 50,
page: 2,
id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
required: false,
assigned_to_user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
options: ['<string>'],
default_to_signing_date: true,
multi_group_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
variable_name: '<string>',
variable_defined_name: '<string>',
required_conditions: {
groups: [
{
conditions: [{field_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a', value: '<string>'}]
}
]
},
visibility_conditions: {
groups: [
{
conditions: [{field_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a', value: '<string>'}]
}
]
}
}
],
reminders: [
{
hours: 2,
subject: '<string>',
message: '<string>',
id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
all_users: false,
user_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a'
}
]
})
};

fetch('https://api.firma.dev/functions/v1/signing-request-api/templates/{id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "name": "<string>",
  "created_date": "2023-11-07T05:31:56Z",
  "description": "<string>",
  "document_url": "<string>",
  "document_url_expires_at": "2023-11-07T05:31:56Z",
  "page_count": 2,
  "expiration_hours": 168,
  "credit_cost": 1,
  "settings": {
    "allow_download": true,
    "attach_pdf_on_finish": true,
    "allow_editing_before_sending": false,
    "use_signing_order": true,
    "hand_drawn_only": false,
    "send_signing_email": true,
    "send_finish_email": true,
    "send_expiration_email": true,
    "send_cancellation_email": true,
    "require_otp_verification": null,
    "disable_guided_navigation": true,
    "allow_presigning_download": true,
    "show_qr_code": true,
    "identity_editable_fields": [
      "<string>"
    ],
    "notify_identity_change_email": false
  },
  "recipients": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "email": "jsmith@example.com",
      "first_name": "<string>",
      "order": 2,
      "name": "<string>",
      "last_name": "<string>",
      "phone_number": "<string>",
      "street_address": "<string>",
      "city": "<string>",
      "state_province": "<string>",
      "postal_code": "<string>",
      "country": "<string>",
      "title": "<string>",
      "company": "<string>",
      "required_fields": [
        "<string>"
      ],
      "missing_fields": [
        "<string>"
      ],
      "required_read_only_fields": [
        {
          "variable_name": "<string>",
          "variable_defined_name": "<string>",
          "field_type": "<string>"
        }
      ],
      "ready_to_send": true
    }
  ],
  "fields": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "page_number": 2,
      "required": true,
      "recipient_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "variable_name": "<string>",
      "variable_defined_name": "<string>",
      "position": {
        "x": 50,
        "y": 50,
        "width": 50,
        "height": 50
      },
      "dropdown_options": [
        "<string>"
      ],
      "multi_group_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "date_default": "2023-12-25",
      "date_signing_default": true,
      "format_rules": {
        "dateFormat": "MMMM dd, yyyy"
      },
      "validation_rules": {},
      "read_only": false,
      "read_only_value": "<string>"
    }
  ],
  "updated_date": "2023-11-07T05:31:56Z"
}
{
"error": "Validation Error",
"message": "Invalid input data",
"details": {
"name": "Name is required",
"email": "Invalid email format"
}
}
{
"error": "Unauthorized",
"message": "Invalid API key"
}
{
"error": "Not Found",
"message": "The requested resource was not found"
}
{
"error": "Rate Limit Exceeded",
"message": "Too many requests. Please wait before retrying.",
"details": {
"retry_after": 45
}
}

Authorizations

Authorization
string
header
required

API key for authentication. Use your API key directly without any prefix (e.g., 'your-api-key'). Bearer prefix is optional but not required.

Path Parameters

id
string<uuid>
required

Body

application/json
template_properties
object

Update template metadata and settings

users
object[]

Upsert users (include id to update, omit to create)

force_remove_conditions
boolean
default:false

When deleting users whose fields are referenced by conditions in other fields: if true, automatically remove the condition references; if false (default), the request will be rejected with an error.

deleted_users
object[]

Users to delete with field handling strategy

fields
object[]

Upsert fields (include id to update, omit to create)

reminders
object[]

Upsert reminders (include id to update, omit to create)

Response

Template updated successfully. Returns full template with all relationships.

id
string<uuid>
required

Unique identifier for the template

name
string
required

Template name

Maximum string length: 255
created_date
string<date-time>
required

Template creation timestamp

description
string | null

Template description

document_url
string<uri>

Pre-signed URL to the PDF document. This is a time-limited signed URL for secure access - see document_url_expires_at for expiration time. Initial URLs are valid for 7 days; refreshed URLs are valid for 1 hour. Request a new template retrieval to get a fresh URL if expired.

document_url_expires_at
string<date-time> | null

ISO 8601 timestamp when the document_url will expire. After this time, the URL will return an access denied error. Fetch the template again to receive a fresh signed URL.

page_count
integer

Number of pages in the document

Required range: x >= 1
expiration_hours
integer
default:168

Hours until signing requests created from this template expire

Required range: x >= 1
credit_cost
integer
default:1

Number of credits consumed when a signing request is sent from this template. Minimum value is 1.

Required range: x >= 1
settings
object

Settings returned by the signing request list and detail endpoints. Templates use the TemplateSettings schema (no identity fields).

recipients
object[]

Template recipients (included in GET single template)

fields
object[]

Template fields (included in GET single template)

updated_date
string<date-time>

Template last update timestamp